package com.bwie.auth.controller;

import com.alibaba.fastjson.JSON;
import com.bwie.auth.service.AuthService;
import com.bwie.common.pojo.DTO.DTOUser;
import com.bwie.common.pojo.User;
import com.bwie.common.pojo.VO.VOUser;
import com.bwie.common.result.Result;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

/**
 * @author 86175
 */
@RestController
@RequestMapping("/auth")
@Log4j2
public class AuthController {

    @Autowired
    private AuthService authService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 手机号发送验证码
     */
    @PostMapping("/sendCode/{phone}")
    public Result sendCode(@PathVariable String phone){

        log.info("功能描述：发送验证码,请求URI:{},请求方式:{},请求参数:{}",request.getServletPath(),request.getMethod(),phone);

        Result result = authService.sendCode(phone);

        log.info("功能描述：发送验证码,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(result));
        return result;
    }

    /**
     * 登录
     */
    @PostMapping("/users")
    public Result<DTOUser> user(@RequestBody VOUser voUser){
        log.info("功能描述：登录验证,请求URI:{},请求方式:{},请求参数:{}",request.getServletPath(),request.getMethod(),voUser);

        Result result=authService.users(voUser);
        log.info("功能描述：登录验证,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(result));
        return result;
    }
    /**
     * 注册
     */
    @PostMapping("/regUser")
    public Result regUser(@RequestBody User user){
        log.info("功能描述：注册,请求URI:{},请求方式:{},请求参数:{}",request.getServletPath(),request.getMethod(),user);
        Result result =authService.regUser(user);
        log.info("功能描述：注册,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(result));
        return result;
    }


}
