package com.bwie.auth.feign;

import com.bwie.common.pojo.User;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @author 86175
 */
@FeignClient("bwie-user")
public interface UserFeignService {

    /**
     * 远程调用查询手机号的方法
     * @param phone
     * @return
     */
    @PostMapping("/user/findByPhone/{phone}")
    public Result<User> findByPhone(@PathVariable String phone);

    /**
     * 调用注册方法
     * @param user
     * @return
     */
    @PostMapping("/user/reg")
    public Result<Integer> regLogin(@RequestBody User user);

}
