package com.bwie.common.pojo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.bwie.common.utils.poi.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 86175
 * 记录销售记录
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Sell {

    /**
     * 销售编号
     */
    @ExcelIgnore
    private Integer sellId;
    /**
     * 商品编号
     */
    @ExcelIgnore
    private Integer shopId;
    /**
     * 卖出的时间
     */
    @Excel(name = "卖出商品的时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date sellTime;
    /**
     * 用户
     */
    @ExcelIgnore
    private Integer userId;
    /**
     * 设备表
     */
    @ExcelIgnore
    private Integer facilityId;
    /**
     * 设备类型
     */
    @Excel(name = "设备类型")
    private String facilityType;
    /**
     * 设备地址
     */
    @Excel(name = "设备地址")
    private String facilitySite;
    /**
     * 补货员工
     */
    @Excel(name = "补货员工")
    private Integer replenishmentUserId;
    /**
     * 维修员工
     */
    @Excel(name = "维修员工")
    private Integer maintainUserId;
    /**
     * 设备状态
     */
    @Excel(name = "设备状态")
    private String facilityStatic;
    /**
     * 删除状态
     */
    @ExcelIgnore
    private Integer delId;
    /**
     * 商品名称
     */
    @Excel(name = "商品名称")
    private String shopName;
    /**
     * 商品价格
     */
    @Excel(name = "商品价格")
    private Double shopPrice;
    /**
     * 类型编号
     */
    @ExcelIgnore
    private Integer typeId;
    /**
     * 商品类型
     */
    @Excel(name = "商品类型")
    private String typeName;
    /**
     * 用户名
     */
    @Excel(name = "用户名")
    public String userName;
    /**
     * 手机号
     */
    @Excel(name = "手机号")
    public String phone;
    /**
     * 邮箱
     */
    @Excel(name = "邮箱")
    public String email;


}
