//package com.bwie.common.utils.poi3;
//
//import com.alibaba.excel.EasyExcel;
//import com.alibaba.excel.ExcelWriter;
//import com.alibaba.excel.metadata.Head;
//import com.alibaba.excel.support.ExcelTypeEnum;
//import com.alibaba.excel.util.CollectionUtils;
//import com.alibaba.excel.write.builder.ExcelWriterSheetBuilder;
//import com.alibaba.excel.write.merge.AbstractMergeStrategy;
//import com.alibaba.excel.write.metadata.WriteSheet;
//import com.alibaba.excel.write.metadata.style.WriteCellStyle;
//import com.alibaba.excel.write.metadata.style.WriteFont;
//import com.alibaba.excel.write.style.HorizontalCellStyleStrategy;
//import lombok.Data;
//import lombok.NoArgsConstructor;
//import org.apache.poi.ss.formula.functions.T;
//import org.apache.poi.ss.usermodel.Cell;
//import org.apache.poi.ss.usermodel.FillPatternType;
//import org.apache.poi.ss.usermodel.IndexedColors;
//import org.apache.poi.ss.usermodel.Sheet;
//import org.apache.poi.ss.util.CellRangeAddress;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Component;
//
//import javax.security.sasl.SaslServer;
//import javax.servlet.http.HttpServletResponse;
//import java.io.IOException;
//import java.io.UnsupportedEncodingException;
//import java.net.URLEncoder;
//import java.util.ArrayList;
//import java.util.Arrays;
//import java.util.List;
//import java.util.stream.Collectors;
//
//// 自定义合并策略 该类继承了AbstractMergeStrategy抽象合并策略，需要重写merge()方法
//@Component
//@Data
//@NoArgsConstructor
//public  class EasyExcelUtil extends AbstractMergeStrategy {
//
//
//    @Autowired
//    private SaslServer saslServer;
//
//    /**
//     * 分组，每几行合并一次
//     */
//    private List<Integer> exportFieldGroupCountList;
//
//    /**
//     * 目标合并列index
//     */
//    private Integer targetColumnIndex;
//
//    // 需要开始合并单元格的首行index
//    private Integer rowIndex;
//
//    // exportDataList为待合并目标列的值
//    public EasyExcelUtil(List<String> exportDataList, Integer targetColumnIndex) {
//        this.exportFieldGroupCountList = getGroupCountList(exportDataList);
//        this.targetColumnIndex = targetColumnIndex;
//    }
//
//
//    @Override
//    protected void merge(Sheet sheet, Cell cell, Head head, Integer relativeRowIndex) {
//
//        if (null == rowIndex) {
//            rowIndex = cell.getRowIndex();
//        }
//        // 仅从首行以及目标列的单元格开始合并，忽略其他
//        if (cell.getRowIndex() == rowIndex && cell.getColumnIndex() == targetColumnIndex) {
//            mergeGroupColumn(sheet);
//        }
//    }
//
//    private void mergeGroupColumn(Sheet sheet) {
//        int rowCount = rowIndex;
//        for (Integer count : exportFieldGroupCountList) {
//            if(count == 1) {
//                rowCount += count;
//                continue ;
//            }
//            // 合并单元格
//            CellRangeAddress cellRangeAddress = new CellRangeAddress(rowCount, rowCount + count - 1, targetColumnIndex, targetColumnIndex);
//            sheet.addMergedRegionUnsafe(cellRangeAddress);
//            rowCount += count;
//        }
//    }
//
//    // 该方法将目标列根据值是否相同连续可合并，存储可合并的行数
//    private List<Integer> getGroupCountList(List<String> exportDataList){
//        if (CollectionUtils.isEmpty(exportDataList)) {
//            return new ArrayList<>();
//        }
//
//        List<Integer> groupCountList = new ArrayList<>();
//        int count = 1;
//
//        for (int i = 1; i < exportDataList.size(); i++) {
//            if (exportDataList.get(i).equals(exportDataList.get(i - 1))) {
//                count++;
//            } else {
//                groupCountList.add(count);
//                count = 1;
//            }
//        }
//        // 处理完最后一条后
//        groupCountList.add(count);
//        return groupCountList;
//    }
//
//
//    // 修改WriteSheet的代码如下
//    public void writeExcel(HttpServletResponse response,String fileName,Integer mergeIndex,String firstTitle,String [] secondTile,Integer sheetSize) {
//        // 这里注意 有同学反应使用swagger 会导致各种问题，请直接用浏览器或者用postman
//        response.setContentType("application/vnd.ms-excel");
//        response.setCharacterEncoding("utf-8");
//        // 这里URLEncoder.encode可以防止中文乱码 当然和easyexcel没有关系
//        try {
//            String name = URLEncoder.encode(fileName, "UTF-8");
//
//            response.setHeader("Content-disposition", "attachment;filename=" + name + ".xlsx");
//
//            List<List<String>> heads = new ArrayList<>();
//            for (int i = 0; i < secondTile.length; i++) {
//                heads.add(Arrays.asList(firstTitle,secondTile[i]));
//            }
//
//
//
//
//                ExcelWriter excelWriter = EasyExcel.write(response.getOutputStream())
//                        .build();
//
//            List<Student> studentListAll = studentService.findStudentListAll();
//            //select * from t_student limit 0,2       1     (pageNum-1)*pageSize
//            //select * from t_student limit 2,2       2
//            //select * from t_student limit 4,2       3
//            //select * from t_student limit 6,2       4
//
//            Integer count = studentListAll.size();
//            Integer sheets = (int)Math.ceil((double)count/sheetSize);
//
//
//
//            for (int i = 0; i < sheets; i++) {
//                PageInfo<Student> studentList = studentService.findStudentList(i + 1, sheetSize);
//                WriteSheet sheet1 = EasyExcel.writerSheet(i, "模版"+(i+1)).head(Student.class)
//                        .head(heads).registerWriteHandler(new EasyExcelUtil(studentList.getList().stream().map(Student::getSex).collect(Collectors.toList()), mergeIndex))
//                        .registerWriteHandler(new CustomCellStyle()).build();
//
//
//                excelWriter.write(studentList.getList(),sheet1);
//            }
//
//
//                excelWriter.finish();
//                response.flushBuffer();
//
//
//
//
//
//        } catch (UnsupportedEncodingException e) {
//            e.printStackTrace();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//
//    }
//
//
//    // 修改WriteSheet的代码如下
//    public void writeExcel(HttpServletResponse response,String fileName, List<Student> list,String [] secondTile) {
//        // 这里注意 有同学反应使用swagger 会导致各种问题，请直接用浏览器或者用postman
//        response.setContentType("application/vnd.ms-excel");
//        response.setCharacterEncoding("utf-8");
//        // 这里URLEncoder.encode可以防止中文乱码 当然和easyexcel没有关系
//        try {
//            String name = URLEncoder.encode(fileName, "UTF-8");
//
//            response.setHeader("Content-disposition", "attachment;filename=" + name + ".xlsx");
//
//            List<List<String>> heads = new ArrayList<>();
//            for (int i = 0; i < secondTile.length; i++) {
//                heads.add(Arrays.asList(secondTile[i]));
//            }
//
//
//            EasyExcel.write(response.getOutputStream(),Student.class).sheet("模板").head(Student.class)
//                    .head(heads)
//                    //.registerWriteHandler(new EasyExcelUtil(list.stream().map(Student::getName).collect(Collectors.toList()), mergeIndex))
//                    //.registerWriteHandler(new CustomCellStyle())   //设置单元格颜色样式
//                    .doWrite(list);
//
//
//        } catch (UnsupportedEncodingException e) {
//            e.printStackTrace();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//
//    }
//
//
//
//}