package com.bwie.buy.controller;

import com.alibaba.fastjson.JSONObject;
import com.bwie.buy.service.BuyService;
import com.bwie.common.pojo.VO.VOGoods;
import com.bwie.common.result.Result;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * @author FangShiBa
 * @date 2023/12/17
 * @apiNote
 */
@Log4j2
@RestController
@RequestMapping("/buy")
public class BuyController {
    @Autowired
    private BuyService service;
    @Autowired
    private HttpServletRequest request;

    /*
    商品列表展示,购买商品时展示
     */
    @PostMapping("/showGoodsList")
    public Result showGoodsList(@RequestBody VOGoods voGoods){

        log.info("功能：{商品列表展示}，请求URI：{}，请求方法：{}，请求参数：{}",
                request.getRequestURI(), request.getMethod(),voGoods );
        Result result=service.showGoodsList(voGoods);
        log.info("功能：{商品列表展示}，请求URI：{}，请求方法：{}，响应参数：{}",
                request.getRequestURI(), request.getMethod(), JSONObject.toJSONString(result));
        return result;
    }

    /*
    购买商品
     */
    @PostMapping("/buyGood")
    public Result buyGood(@RequestBody VOGoods voGoods){

        log.info("功能：{购买商品}，请求URI：{}，请求方法：{}，请求参数：{}",
                request.getRequestURI(), request.getMethod(),voGoods );
        Result result=service.buyGood(voGoods);
        log.info("功能：{购买商品}，请求URI：{}，请求方法：{}，响应参数：{}",
                request.getRequestURI(), request.getMethod(), JSONObject.toJSONString(result));
        return result;
    }



}
