package com.bwie.sell.controller;

import com.alibaba.fastjson.JSON;
import com.bwie.common.pojo.Sell;
import com.bwie.common.result.Result;
import com.bwie.sell.service.SellService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

import static org.bouncycastle.asn1.cmc.CMCStatus.success;

/**
 * @author 86175
 */
@RestController
@RequestMapping("/sell")
@Log4j2
public class SellController {

    @Autowired
    public SellService sellService;
    @Autowired
    public HttpServletRequest request;


    /**
     * 商品销售统计
     * 查出每台售货机卖的
     */
    @PostMapping("/shopStatistics")
    public Result<List<Sell>> listResult (){

        log.info("功能描述：销售日志统计,请求URI:{},请求方式:{}",request.getServletPath(),request.getMethod());
        List<Sell> sell=sellService.list();
        Result<List<Sell>> success = Result.success(sell);
        log.info("功能描述：销售日志统计,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(success));
        return success;
    }
    /**
     * 销售统计表展示
     */
    @PostMapping("/salesStatistics")
    public Result<List<Sell>> salesStatistics (){

        log.info("功能描述：销售金额统计,请求URI:{},请求方式:{}",request.getServletPath(),request.getMethod());
        List<Sell> sell=sellService.sellList();
        Result<List<Sell>> success = Result.success(sell);
        log.info("功能描述：销售金额统计,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(success));
        return success;
    }

    /**
     * 商品销售统计导出
     */
    @PostMapping("/exportSell")
    public Result exportSell(HttpServletResponse response){
//        Result success =
                //先查询数据
        System.out.println(response);
        log.info("功能描述：销售导出查询,请求URI:{},请求方式:{},请求参数{}",request.getServletPath(),request.getMethod(),response);
       Result success =sellService.exportSell(response);
        log.info("功能描述：销售导出查询,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(success));
        return success;

    }
}
