package com.bwie.sell.service.impl;

import com.bwie.common.pojo.Sell;
import com.bwie.common.result.Result;
import com.bwie.common.utils.poi.ExcelUtil;
import com.bwie.sell.mapper.SellMapper;
import com.bwie.sell.service.SellService;
import com.bwie.sell.util.poi3.EasyExcelUtil;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * @author 86175
 */
@Service
public class SellServiceImpl implements SellService {

    @Autowired
    public SellMapper sellMapper;

    @Autowired
    public EasyExcelUtil easyExcelUtil;


    @Override
    public List<Sell> list() {
        return sellMapper.shopList();
    }

    @Override
    public List<Sell> sellList() {
        return sellMapper.sellList();
    }

    @Override
    public Result exportSell(HttpServletResponse response) {

        List<Sell> sells = sellMapper.sellList();
        //是以流的方式把数据传给用户
        ExcelUtil<Sell> sellExcelUtil = new ExcelUtil<>(Sell.class);
        /**
         * sellExcelUtil  对象中的导出的方法 中第一次参数的是：
         *                                            响应对象
         *                                 第二个参数是：
         *                                            查询到的list集合
         *                                 第三个参数是：
         *                                            sheet名称
         *
         */
        String s = sellExcelUtil.exportExcel(sells, "商品销售统计");
//        return Result.success();
        return Result.success(s);
    }

    @Override
    public List<Sell> findStudentListAll() {
        return null;
    }

    @Override
    public PageInfo<Sell> findStudentList(int i, Integer sheetSize) {
        return null;
    }
}
