package com.bwie.list.controller;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.pojo.VO.VOGoods;
import com.bwie.common.result.Result;
import com.bwie.list.service.GoodsService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@Log4j2
public class GoodsController {
    @Autowired
    private GoodsService goodsService;
    @Autowired
    private HttpServletRequest request;

    @PostMapping("/goodsList")
    public Result goodsList(@RequestBody VOGoods voGoods){
        log.info("功能名称:[查询商品设备表],请求URI:{},请求方式:{},请求参数:{}",
                request.getRequestURI(),request.getMethod(),voGoods);

        Result result = goodsService.goodsList(voGoods);

        log.info("功能名称:[查询商品设备表],请求URI:{},请求方式:{},响应结果:{}",
                request.getRequestURI(),request.getMethod(), JSONObject.toJSONString(result));

        return result;
    }

    @PostMapping("/topShop")
    public Result topShop(@RequestBody VOGoods voGoods){
        log.info("功能名称:[上架],请求URI:{},请求方式:{},请求参数:{}",
                request.getRequestURI(),request.getMethod(),voGoods);
        Result result = goodsService.topShop(voGoods);
        log.info("功能名称:[上架],请求URI:{},请求方式:{},响应结果:{}",
                request.getRequestURI(),request.getMethod(), JSONObject.toJSONString(result));

        return result;
    }

    @PostMapping("/bottomShop")
    public Result bottomShop(@RequestBody VOGoods voGoods){
        log.info("功能名称:[下架],请求URI:{},请求方式:{},请求参数:{}",
                request.getRequestURI(),request.getMethod(),voGoods);
        Result result = goodsService.bottomShop(voGoods);
        log.info("功能名称:[下架],请求URI:{},请求方式:{},响应结果:{}",
                request.getRequestURI(),request.getMethod(), JSONObject.toJSONString(result));
        return result;
    }

    @PostMapping("/addGoodsNum")
    public Result addGoodsNum(@RequestBody VOGoods voGoods){
        return goodsService.addGoodsNum(voGoods);
    }

}
