package com.bwie.list.controller;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.result.Result;
import com.bwie.list.service.TypeService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@Log4j2
public class TypeController {
    @Autowired
    private TypeService typeService;
    @Autowired
    private HttpServletRequest request;

    // 根据商品类型查询商品的商品类型菜单栏
    @GetMapping("/findType")
    public Result findType(){

        log.info("功能名称:[类型菜单栏],请求URI:{},请求方式:{},请求参数:{}",
                request.getRequestURI(),request.getMethod(),"");

        Result result = typeService.findType();

        log.info("功能名称:[类型菜单栏],请求URI:{},请求方式:{},响应结果:{}",
                request.getRequestURI(),request.getMethod(), JSONObject.toJSONString(result));

        return result;
    }

}
