package com.bwie.list.service.impl;

import com.bwie.common.pojo.DTO.DTOGoods;
import com.bwie.common.pojo.Goods;
import com.bwie.common.pojo.VO.VOGoods;
import com.bwie.common.result.Result;
import com.bwie.list.mapper.GoodsMapper;
import com.bwie.list.service.GoodsService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class GoodsServiceImpl implements GoodsService {
    @Autowired
    private GoodsMapper goodsMapper;

    @Override
    public Result goodsList(VOGoods voGoods) {

        PageHelper.startPage(voGoods.getPageNum(), voGoods.getPageSize());

        List<DTOGoods> dtoGoodsList = goodsMapper.goodsList(voGoods);

        PageInfo<DTOGoods> info = new PageInfo<>(dtoGoodsList);

        return Result.success(info,"商品设备中间表");
    }

    @Override
    public Result topShop(VOGoods voGoods) {

       Goods goods = goodsMapper.findShopId(voGoods.getShopId(),voGoods.getFacilityId());
       if (goods==null){
           Integer i = goodsMapper.addGoods(voGoods);
           if (i>0){
               return Result.success(voGoods,"上架成功");
           }
       } else {
           if (goods.getGoodsIsDelete() == 0){
               Integer i = goodsMapper.changeGoodsState(goods.getGoodsId());
               if (i>0){
                   return Result.success(voGoods,"上架成功");
               }
           }
       }

        return Result.error("商品已上架不能重复上架哦~~");
    }

    @Override
    public Result bottomShop(VOGoods voGoods) {
        Goods goods = goodsMapper.findShopId(voGoods.getShopId(),voGoods.getFacilityId());
        if (goods==null){

            return Result.error("商品还未上架");

        }else {

            if (goods.getGoodsIsDelete()==1){
                Integer i = goodsMapper.updateGoodsState(goods.getGoodsId());
                if (i>0){
                    return Result.success(voGoods,"下架成功");
                }else {
                    return Result.error("下架失败");
                }
            }

        }

        return Result.error("商品已经下架");
    }

    @Override
    public Result addGoodsNum(VOGoods voGoods) {
        Integer i = goodsMapper.changeGoodsNum(voGoods);
        if (i>0){
            return Result.success(voGoods,"进货成功");
        }
        return Result.error("进货失败");
    }
}
