package com.bwie.list.service.impl;

import com.bwie.common.pojo.DTO.DTOShop;
import com.bwie.common.pojo.VO.VOShop;
import com.bwie.common.result.Result;
import com.bwie.common.utils.FastUtil;
import com.bwie.list.mapper.ShopMapper;
import com.bwie.list.service.ShopService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@Service
public class ShopServiceImpl implements ShopService {
    @Autowired
    private ShopMapper shopMapper;
    @Autowired
    private FastUtil fastUtil;

    @Override
    public Result shopList(VOShop voShop) {

        PageHelper.startPage(voShop.getPageNum(),voShop.getPageSize());

        List<DTOShop> dtoShops = shopMapper.shopList(voShop);

        PageInfo<DTOShop> info = new PageInfo<>(dtoShops);

        return Result.success(info,"商品列表展示");
    }

    @Override
    public Result addShop(VOShop shop) {

        Integer i = shopMapper.addShop(shop);
        if (i>0){
            shopMapper.addImg(shop);
            return Result.success(shop,"成功");
        }
        return Result.error("失败");
    }

    @Override
    public Result upImg(MultipartFile myFile) {

        String url = null;

        try {
            url = fastUtil.upload(myFile);

            if (url==null || url.equals("")){
                return Result.error("图片上传失败");
            }

        } catch (Exception e) {
            throw new RuntimeException(e);
        }


        return Result.success("http://82.157.236.130:8888/"+url,"上传成功");
    }
}
