package com.bwie.user.controller;

import com.alibaba.fastjson.JSON;
import com.bwie.common.pojo.User;
import com.bwie.common.result.Result;
import com.bwie.user.service.UserService;
import lombok.extern.log4j.Log4j2;
import org.hibernate.validator.constraints.Length;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

/**
 * @author 86175
 */
@RestController
@RequestMapping("/user")
@Log4j2
public class UserController {

    @Autowired
    private HttpServletRequest request;

    @Autowired
    private UserService userService;

    /**
     * 后台查询是否存在该手机号
     */
    @PostMapping("/findByPhone/{phone}")
    public Result<User> findByPhone(@PathVariable String phone){

        log.info("功能描述：后台是否存在该手机号,请求URI:{},请求方式:{},请求参数:{}",request.getServletPath(),request.getMethod(),phone);
        User user=userService.findByPhone(phone);
        Result result=Result.success(user);
        log.info("功能描述：查询是否存在该手机号,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(result));
        return result;
    }
    /**
     * 注册
     */
    @PostMapping("/reg")
    public Result<Integer> regLogin(@RequestBody User user){
        log.info("功能描述：注册调用,请求URI:{},请求方式:{},请求参数:{}",request.getServletPath(),request.getMethod(),user);
        Integer add =userService.reg(user);
        Result<Integer> result = Result.success(add);
        log.info("功能描述：注册调用,请求URI:{},请求方式:{},响应结果:{}",request.getServletPath(),request.getMethod(), JSON.toJSONString(result));

        return result;
    }


}
